;   + 

PUSK            BIT     2AH.0 ;  .    . .
PUSK1           BIT     2AH.1 ;   HL1
PUSK2           BIT     2AH.2 ;   . 
PUSK3           BIT     2AH.3 ;   


FLAG1	  	BIT	2BH.1 	;  . . 1
FLAG2	  	BIT	2BH.2	;  . . 2
FLAG3	  	BIT	2BH.3	;  . . 3
FLAG4	  	BIT	2BH.4	;  . . 4
FLAG5	  	BIT	2BH.5	;  . . 5
FLAG6	  	BIT	2BH.6	;  . . 6
FLAG7	  	BIT	2BH.7	;  . . 7

FLAM1	  	BIT	2CH.1 ;     3 
FLAM2	  	BIT	2CH.2
FLAM3	  	BIT	2CH.3
FLAM4	  	BIT	2CH.4
FLAM5	  	BIT	2CH.5
FLAM6	  	BIT	2CH.6
FLAM7	  	BIT	2CH.7

        JMP     INIT

        ORG     0BH
        JMP     OT
                                                
INIT:   CLR      A
	MOV	 R1,#200
	MOV	 R4,#255;	;
	MOV	 R2,#10
	MOV	 R3,#20;
	MOV	 R5,#10
	MOV	 R6,#20;
	MOV	 R7,#4
        MOV      TMOD,#00000001B   
        MOV      TL0,#LOW(-3400)
        MOV      TH0,#HIGH(-3400)
	MOV	 P3,#11111111B                
	MOV	 P1,#11111111B                
        SETB     PUSK             
       	SETB     PUSK1            
       	SETB     PUSK2
	SETB     PUSK3
	CLR	 FLAM1
	CLR	 FLAM2
	CLR	 FLAM3	
	CLR	 FLAM4
	CLR	 FLAM5
	CLR	 FLAM6
	CLR	 FLAM7
	CLR	 FLAG1
	CLR	 FLAG2
	CLR	 FLAG3	
	CLR	 FLAG4
	CLR	 FLAG5
	CLR	 FLAG6
	CLR	 FLAG7

	SETB	 C	
	SETB     TR0              
        SETB     ET0  
       	SETB     EA 

SE1:	NOP
	JMP	 SE1

OT:	CLR      TR0  		;     TR0 
	MOV      TL0,#LOW(-3400)         
	MOV      TH0,#HIGH(-3400)     
	SETB     TR0
	PUSH	 PSW                     
	PUSH     ACC 

EMOV2:	DJNZ	 R1,SAL0
	MOV	 R1,#200

	CPL	 P1.7		;   VT5 

	JB	PUSK1,SW1
	CPL	P3.3 		;  HL1
SW1:	JB	P3.4,SAV0

	JB	P3.5,VEL1	; 6   10 
	DJNZ	R2,SLEV
	MOV	R2,#10;
	CLR	PUSK1
	JMP	SLEV

VEL1:	DJNZ	R3,SLEV
	MOV	R3,#20;	
	CLR	PUSK1
	JMP	SLEV

SAV0:   MOV	R2,#10;
	MOV	R3,#20;
	SETB	PUSK1
	SETB    PUSK3
	SETB	P3.0
	SETB	P3.1
	SETB	P3.3
	SETB	P3.2

SLEV:	JB	 FLAM1,SLEK
	JB	 FLAM2,SLEK
	JB	 FLAM3,SLEK
	JB	 FLAM4,SLEK
	JB	 FLAM5,SLEK
	JB	 FLAM6,SLEK
	JB	 FLAM7,SLEK
	JMP      SAL0

SLEK:	DJNZ	 R7,SL2
	MOV	 R7,#4
	CLR	 FLAM1
	CLR	 FLAM2
	CLR	 FLAM3	
	CLR	 FLAM4
	CLR	 FLAM5
	CLR	 FLAM6
	CLR	 FLAM7
	SETB     P3.2
	JMP      SAL0

SL2:	CPL      P3.2

SAL0:	SETB	 PUSK		;   
	
	
SA0:	JB	P1.0,SAM0;	S1- ?
	CLR	PUSK
	JB	FLAG1,SA1
	SETB	FLAG1
	SETB	FLAM1
	JMP	SA1
SAM0:	CLR	FLAG1


SA1:	JB	P1.1,SAM1;	S2- ?
	CLR	PUSK
	JB	FLAG2,SA2
	SETB	FLAG2
	SETB	FLAM2
	JMP	SA2
SAM1:	CLR	FLAG2

SA2:	JB	P1.2,SAM2;	S3- ?
	CLR	PUSK
	JB	FLAG3,SA3
	SETB	FLAG3
	SETB	FLAM3
	JMP	SA3
SAM2:	CLR	FLAG3

SA3:	JB	P1.3,SAM3;	S4- ?
	CLR	PUSK
	JB	FLAG4,SA4
	SETB	FLAG4
	SETB	FLAM4
	JMP	SA4
SAM3:	CLR	FLAG4

SA4:	JB	P1.4,SAM4;	S5- ?
	CLR	PUSK
	JB	FLAG5,SA5
	SETB	FLAG5
	SETB	FLAM5
	JMP	SA5
SAM4:	CLR	FLAG5

SA5:	JB	P1.5,SAM5;	S6- ?
	CLR	PUSK
	JB	FLAG6,SA6
	SETB	FLAG6
	SETB	FLAM6
	JMP	SA6
SAM5:	CLR	FLAG6

SA6:	JB	P1.6,SAM6;	S7- ?
	CLR	PUSK
	JB	FLAG7,SA10
	SETB	FLAG7
	SETB	FLAM7
	JMP	SA10
SAM6:	CLR	FLAG7


SA10:	JB	PUSK1,SA11
	JB	PUSK3,SA15
	JMP     SWO1
SA15:	JB	PUSK,SA11
	
SWO1:	JB	P3.4,SAK1	
	DJNZ	R4,SA11
	MOV	R4,#255
	
	JB	PUSK2,SWO2

	CPL	P3.0
	CLR	P3.1
	CPL	P3.2

SWO2:	JB	P3.5,FEK1
	DJNZ	R5,SA11
	MOV	R5,#10;
	CLR	PUSK2
	CLR	PUSK3
	JMP	SA11

FEK1:	DJNZ	R6,SA11
	MOV	R6,#20;	
	CLR	PUSK2
	CLR	PUSK3
	JMP	SA11

SAK1:   MOV	R5,#10;
	MOV	R6,#20;
	SETB	PUSK2
		
SA11:	NOP
	POP	ACC
	POP	PSW
	RETI
	END

